// playfield.h
#ifndef _PLAYFIELD_H
#define _PLAYFIELD_H
#include <QtGui>
#include "twodvector.h"
class PlayField: public QWidget
{
public:
  PlayField(QWidget *parent = 0);
  // no destructor since no attributed are created using new
protected:
  void paintEvent(QPaintEvent *event);  
  void keyPressEvent(QKeyEvent * event);
  void mouseMoveEvent(QMouseEvent * event);
private:
  int pf_leftPaddleCenterY;
  int pf_rightPaddleCenterY;
  TwoDVector pf_ballPosition; // convert to int only for drawing
  TwoDVector pf_ballVelocity; // unit vector
  void updateBallPosition(int & bx, int & by);
  void findNewVelocity(const TwoDVector & normalVector);
};
#endif

