#ifndef _TWODVECTOR_H_
#define _TWODVECTOR_H_
// This class handles two-dimensional analytic geometry. C++ or
// Qt's vector classes are container classes.
//
class TwoDVector
{
public:
  TwoDVector(double x = 1.0, double y = 1.0, bool unit = true);
  void reflect(const TwoDVector & vin, TwoDVector & vout) const;
  // the object is the unit vector, given the incident vector, find
  // the reflective vector. using passing-by-reference to reduce the
  // overhead of copying objects
  double innerProduct(const TwoDVector & v2) const;
  double getX() { return tdv_x; }
  double getY() { return tdv_y; }
  void addVector(const TwoDVector & vec);
  void print();
private:
  void makeUnit(); // keep it a unit vector
  double tdv_x;
  double tdv_y;
  bool unitVector;
};
extern void testVectorReflect(); 
// generate a set of vin and normal to test vout

#endif
